#include "ConfigLoader.h"

void LoadConfiguration(const char* fileName, int* popSize, int* cycles, int* rnd_seed, int display){
    FILE* inFile = fopen(fileName, "r");
    if(inFile){
        int read = fscanf(inFile, "Population_size: %d\n", popSize);
        if(read!=1 || *popSize <= 0){
            printf("Fatal Error. Invalid population size!\n"); exit(1);
        }

        read = fscanf(inFile, "Cycles: %d\n", cycles);
        if(read!=1 || *cycles <= 0){
            printf("Fatal Error. Invalid number of cycles!<\n"); exit(1);
        }

        read = fscanf(inFile, "Random_seed: %d\n", rnd_seed);
        if(read!=1 || *rnd_seed <= 0){
            printf("Fatal Error. Invalid seed!<\n"); exit(1);
        }
        if(display){
            printf("Population size: %d\n", *popSize);
            printf("Cycles: %d\n", *cycles);
            printf("Random seed: %d\n", *rnd_seed);
        }
    }else{
        printf("Fatal Error. Configuration file not found!<\n"); exit(1);
    }
    fclose(inFile);
}
