#include "PopulationInitializer.h"

//MONOLITIC GENERATION -> The master generates the initial population (it may evaluate them in parallel <OpenMP>)

void Initialize_Population(double* popCosts, double* population, double (*objectiveFunction)(double*), int init, int ending, int numVars, int popSize, double* bounds){
    int focusPop = 0;
    int varFocus = 0;
    int twoVFocus = 0;
    double randomValue = 0.0;  
    
    for(int i = init; i<((ending-init)*numVars); i++){//<The master generates the whole initial population>
	focusPop = i/numVars;
	varFocus = i%numVars;
	twoVFocus = 2*varFocus;
	randomValue = ((double) rand()/RAND_MAX);
	population[focusPop*numVars + varFocus] = randomValue*(bounds[twoVFocus + 1] - bounds[twoVFocus]) + bounds[twoVFocus];//Rand[0,1]*(Max-Min) + Min
    }
    
    #pragma omp parallel for
    for(int i = 0; i< popSize; i++){//Saving the corresponding value of the new individual
        popCosts[i] = objectiveFunction(&population[i*numVars]);
    }    
}