#include "RemoveDuplicates.h"

//Only for sequential execution in this current version -> FocusStart should be 0 and focusEnd should be popSize

int RemoveDuplicates(double* newPopCosts, double* newPopulation, double* bounds, double (*objFunc)(double*), int numVars, int focusStart, int focusEnd){

    int equalityFlag = 0;
    int focusPop = 0;
    int focusSamePop = 0;
    int subject = 0;
    int varFocus = 0;
    double newValue = 0.0;
    int foundDuplicates = 0;//No duplicates found yet

    for(int i = 0; i < focusEnd-1; i++){
        focusSamePop = i*numVars;//j = (focusStart>i+1?focusStart:i+1) -> Experimental parallel version
        for(int j = i+1; j < focusEnd; j++){
            if(are_equal(newPopCosts[i], newPopCosts[j])){//In this case, we should check the configuration of the individual
                focusPop = j*numVars;
                equalityFlag = 1;//Equality of all subjects
                for(int k = 0; k<numVars; k++){
                    if(!are_equal(newPopulation[focusPop+k], newPopulation[focusSamePop+k])){
                        equalityFlag = 0;
                        break;//As they are different, we can stop checking
                    }
                }
                if(equalityFlag){
		    foundDuplicates = 1;//At least a duplicate has been found
                    subject = rand()%numVars;//Which subject should I try to change?
                    varFocus = 2*subject;
                    newValue = ((double)rand()/RAND_MAX)*(bounds[varFocus + 1] - bounds[varFocus]) + bounds[varFocus];//Rand[0,1]*(Max-Min) + Min
                    newPopulation[focusPop + subject] = newValue;
                    newPopCosts[j] = objFunc(&newPopulation[focusPop]);//WARNING, IT IS THE SAME PROCEDURE THAT CAN BE SEEN IN THE TLBO IMPLEMENTATION BUT THIS COULD NOT SOLVE THE COLLISION
                }
            }
        }
    }
    return foundDuplicates;
}

//Auxiliary functions:
int are_equal(double a, double b){
    if(fabs(a - b)<=SENSIBILITY){
        return 1;
    }
    return 0;
}
